diff --git a/drivers/staging/wilc1000/host_interface.c b/drivers/staging/wilc1000/host_interface.c
index f3a56e5..0f1eb17 100644
--- a/drivers/staging/wilc1000/host_interface.c
+++ b/drivers/staging/wilc1000/host_interface.c
@@ -909,7 +909,7 @@ static s32 handle_connect(struct wilc_vif *vif,
 	struct wid wid_list[8];
 	u32 wid_cnt = 0, dummyval = 0;
 	u8 *cur_byte = NULL;
-	struct join_bss_param *ptstrJoinBssParam;
+	struct join_bss_param *bss_param;
 	struct host_if_drv *hif_drv = vif->hif_drv;
 
 	if (memcmp(pstrHostIFconnectAttr->bssid, wilc_connected_ssid, ETH_ALEN) == 0) {
@@ -918,8 +918,8 @@ static s32 handle_connect(struct wilc_vif *vif,
 		return result;
 	}
 
-	ptstrJoinBssParam = pstrHostIFconnectAttr->params;
-	if (!ptstrJoinBssParam) {
+	bss_param = pstrHostIFconnectAttr->params;
+	if (!bss_param) {
 		netdev_err(vif->ndev, "Required BSSID not found\n");
 		result = -ENOENT;
 		goto ERRORHANDLER;
@@ -1031,8 +1031,8 @@ static s32 handle_connect(struct wilc_vif *vif,
 		netdev_err(vif->ndev, "Channel out of range\n");
 		*(cur_byte++) = 0xFF;
 	}
-	*(cur_byte++)  = (ptstrJoinBssParam->cap_info) & 0xFF;
-	*(cur_byte++)  = ((ptstrJoinBssParam->cap_info) >> 8) & 0xFF;
+	*(cur_byte++)  = (bss_param->cap_info) & 0xFF;
+	*(cur_byte++)  = ((bss_param->cap_info) >> 8) & 0xFF;
 
 	if (pstrHostIFconnectAttr->bssid)
 		memcpy(cur_byte, pstrHostIFconnectAttr->bssid, 6);
@@ -1042,57 +1042,57 @@ static s32 handle_connect(struct wilc_vif *vif,
 		memcpy(cur_byte, pstrHostIFconnectAttr->bssid, 6);
 	cur_byte += 6;
 
-	*(cur_byte++)  = (ptstrJoinBssParam->beacon_period) & 0xFF;
-	*(cur_byte++)  = ((ptstrJoinBssParam->beacon_period) >> 8) & 0xFF;
-	*(cur_byte++)  =  ptstrJoinBssParam->dtim_period;
+	*(cur_byte++)  = (bss_param->beacon_period) & 0xFF;
+	*(cur_byte++)  = ((bss_param->beacon_period) >> 8) & 0xFF;
+	*(cur_byte++)  =  bss_param->dtim_period;
 
-	memcpy(cur_byte, ptstrJoinBssParam->supp_rates, MAX_RATES_SUPPORTED + 1);
+	memcpy(cur_byte, bss_param->supp_rates, MAX_RATES_SUPPORTED + 1);
 	cur_byte += (MAX_RATES_SUPPORTED + 1);
 
-	*(cur_byte++)  =  ptstrJoinBssParam->wmm_cap;
-	*(cur_byte++)  = ptstrJoinBssParam->uapsd_cap;
+	*(cur_byte++)  =  bss_param->wmm_cap;
+	*(cur_byte++)  = bss_param->uapsd_cap;
 
-	*(cur_byte++)  = ptstrJoinBssParam->ht_capable;
-	hif_drv->usr_conn_req.ht_capable = ptstrJoinBssParam->ht_capable;
+	*(cur_byte++)  = bss_param->ht_capable;
+	hif_drv->usr_conn_req.ht_capable = bss_param->ht_capable;
 
-	*(cur_byte++)  =  ptstrJoinBssParam->rsn_found;
-	*(cur_byte++)  =  ptstrJoinBssParam->rsn_grp_policy;
-	*(cur_byte++) =  ptstrJoinBssParam->mode_802_11i;
+	*(cur_byte++)  =  bss_param->rsn_found;
+	*(cur_byte++)  =  bss_param->rsn_grp_policy;
+	*(cur_byte++) =  bss_param->mode_802_11i;
 
-	memcpy(cur_byte, ptstrJoinBssParam->rsn_pcip_policy, sizeof(ptstrJoinBssParam->rsn_pcip_policy));
-	cur_byte += sizeof(ptstrJoinBssParam->rsn_pcip_policy);
+	memcpy(cur_byte, bss_param->rsn_pcip_policy, sizeof(bss_param->rsn_pcip_policy));
+	cur_byte += sizeof(bss_param->rsn_pcip_policy);
 
-	memcpy(cur_byte, ptstrJoinBssParam->rsn_auth_policy, sizeof(ptstrJoinBssParam->rsn_auth_policy));
-	cur_byte += sizeof(ptstrJoinBssParam->rsn_auth_policy);
+	memcpy(cur_byte, bss_param->rsn_auth_policy, sizeof(bss_param->rsn_auth_policy));
+	cur_byte += sizeof(bss_param->rsn_auth_policy);
 
-	memcpy(cur_byte, ptstrJoinBssParam->rsn_cap, sizeof(ptstrJoinBssParam->rsn_cap));
-	cur_byte += sizeof(ptstrJoinBssParam->rsn_cap);
+	memcpy(cur_byte, bss_param->rsn_cap, sizeof(bss_param->rsn_cap));
+	cur_byte += sizeof(bss_param->rsn_cap);
 
 	*(cur_byte++) = REAL_JOIN_REQ;
-	*(cur_byte++) = ptstrJoinBssParam->noa_enabled;
+	*(cur_byte++) = bss_param->noa_enabled;
 
-	if (ptstrJoinBssParam->noa_enabled) {
-		*(cur_byte++) = (ptstrJoinBssParam->tsf) & 0xFF;
-		*(cur_byte++) = ((ptstrJoinBssParam->tsf) >> 8) & 0xFF;
-		*(cur_byte++) = ((ptstrJoinBssParam->tsf) >> 16) & 0xFF;
-		*(cur_byte++) = ((ptstrJoinBssParam->tsf) >> 24) & 0xFF;
+	if (bss_param->noa_enabled) {
+		*(cur_byte++) = (bss_param->tsf) & 0xFF;
+		*(cur_byte++) = ((bss_param->tsf) >> 8) & 0xFF;
+		*(cur_byte++) = ((bss_param->tsf) >> 16) & 0xFF;
+		*(cur_byte++) = ((bss_param->tsf) >> 24) & 0xFF;
 
-		*(cur_byte++) = ptstrJoinBssParam->opp_enabled;
-		*(cur_byte++) = ptstrJoinBssParam->idx;
+		*(cur_byte++) = bss_param->opp_enabled;
+		*(cur_byte++) = bss_param->idx;
 
-		if (ptstrJoinBssParam->opp_enabled)
-			*(cur_byte++) = ptstrJoinBssParam->ct_window;
+		if (bss_param->opp_enabled)
+			*(cur_byte++) = bss_param->ct_window;
 
-		*(cur_byte++) = ptstrJoinBssParam->cnt;
+		*(cur_byte++) = bss_param->cnt;
 
-		memcpy(cur_byte, ptstrJoinBssParam->duration, sizeof(ptstrJoinBssParam->duration));
-		cur_byte += sizeof(ptstrJoinBssParam->duration);
+		memcpy(cur_byte, bss_param->duration, sizeof(bss_param->duration));
+		cur_byte += sizeof(bss_param->duration);
 
-		memcpy(cur_byte, ptstrJoinBssParam->interval, sizeof(ptstrJoinBssParam->interval));
-		cur_byte += sizeof(ptstrJoinBssParam->interval);
+		memcpy(cur_byte, bss_param->interval, sizeof(bss_param->interval));
+		cur_byte += sizeof(bss_param->interval);
 
-		memcpy(cur_byte, ptstrJoinBssParam->start_time, sizeof(ptstrJoinBssParam->start_time));
-		cur_byte += sizeof(ptstrJoinBssParam->start_time);
+		memcpy(cur_byte, bss_param->start_time, sizeof(bss_param->start_time));
+		cur_byte += sizeof(bss_param->start_time);
 	}
 
 	cur_byte = wid_list[wid_cnt].val;